/**
 Classe: FeriadoMovel
 Autor:  Ivan Mecenas
 Data:   09/10/2002
*/
import java.util.*;

public class FeriadoMovel {

   static {
     System.out.println("***********************************");
     System.out.println("Essa classe calcula feriados mveis");
     System.out.println("***********************************");
     System.out.println("");
   }

   public static void main(String[] args) {
     String dtFeriado;
     FeriadoMovel obj = new FeriadoMovel();
     dtFeriado = obj.retornaFeriadoMovel(2002, 7);
     System.out.println("Feriado: " + dtFeriado);
   }

   private String retornaFeriadoMovel(int ano, int feriado) {
     int a, b, c, d, e, mes, dia;
     Calendar dtRet = Calendar.getInstance();

     a = ano % 4;
     b = ano % 7;
     c = ano % 19;
     d = (19 * c + 24) % 30;
     e = (2 * a + 4 * b + 6 * d + 5) % 7;

     if ((22 + d + e) > 31) {
       dia = d + e - 9;
       mes = 4;
     }
     else {
       dia = d + e + 22;
       mes = 3;
     }

     switch (feriado) {
       case 1: // Domingo de Pscoa
         dtRet.set(ano, --mes, dia);
         break;

       case 2: // Quinta-Feira Santa
         dtRet.set(ano, --mes, dia);
         dtRet.add(Calendar.DATE, -3);
         break;

       case 3: // Sexta-Feira Santa
         dtRet.set(ano, --mes, dia);
         dtRet.add(Calendar.DATE, -2);
         break;

       case 4: // Corpus Christ
         dtRet.set(ano, --mes, dia);
         dtRet.add(Calendar.DATE, +60);
         break;

       case 5: // Segunda-Feira de Carnaval
         dtRet.set(ano, --mes, dia);
         dtRet.add(Calendar.DATE, -48);
         break;

       case 6: // Tera-Feira de Carnaval
         dtRet.set(ano, --mes, dia);
         dtRet.add(Calendar.DATE, -47);
         break;

       case 7: // Quarta-Feira de Cinzas
         dtRet.set(ano, --mes, dia);
         dtRet.add(Calendar.DATE, -46);
         break;

       default: // Domingo de Pscoa
         dtRet.set(ano, --mes, dia);
     }

     return formataStrData(dtRet.get(Calendar.DATE),
       dtRet.get(Calendar.MONTH) + 1,
       dtRet.get(Calendar.YEAR));
   }

   private String formataStrData(int dia, int mes, int ano) {
     String diaX = "" + dia;
     String mesX = "" + mes;

     for (int i = 1; diaX.length() < 2; i++)
       diaX = "0" + diaX;

     for (int i = 1; mesX.length() < 2; i++)
       mesX = "0" + mesX;

     return diaX + "/" + mesX + "/" + ano;
   }
}
