/**
  Classe: FrameLayoutSeis
  Autor:  Ivan Mecenas
  Data:   22/11/2002
*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class FrameLayoutSeis extends JFrame {

  GridBagLayout gbag = new GridBagLayout();
  GridBagConstraints gcons = new GridBagConstraints();

  public FrameLayoutSeis() {

    super("GridBagLayout - Demonstrao");

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });

    getContentPane().setFont(new Font("Arial", Font.PLAIN, 12));
    getContentPane().setLayout(gbag);

    gcons.fill = GridBagConstraints.BOTH;
    gcons.weightx = 1.0;
    criaBotao("Boto 1", gbag, gcons);
    criaBotao("Boto 2", gbag, gcons);
    criaBotao("Boto 3", gbag, gcons);

    gcons.gridwidth = GridBagConstraints.REMAINDER;
    criaBotao("Boto 4", gbag, gcons);

    gcons.weightx = 0.0;
    criaBotao("Boto 5", gbag, gcons);

    gcons.gridwidth = GridBagConstraints.RELATIVE;
    criaBotao("Boto 6", gbag, gcons);

   gcons.gridwidth = GridBagConstraints.REMAINDER;
   criaBotao("Boto 7", gbag, gcons);

   gcons.gridwidth = 1;
   gcons.gridheight = 2;
   gcons.weighty = 1.0;
   criaBotao("Boto 8", gbag, gcons);

   gcons.weighty = 0.0;
   gcons.gridwidth = GridBagConstraints.REMAINDER;
   gcons.gridheight = 1;
   criaBotao("Boto 9", gbag, gcons);
   criaBotao("Boto 10", gbag, gcons);
  }

  public static void main(String args[]) {
    FrameLayoutSeis frame = new FrameLayoutSeis();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    frame.pack();
    frame.setSize(new Dimension(600, 400));
    frame.setLocation((screenSize.width-600)/2,(screenSize.height-400)/2);
    frame.setVisible(true);
  }

  private void criaBotao(String nome, GridBagLayout gb,
                         GridBagConstraints gc) {
    Button btn = new Button(nome);
    gb.setConstraints(btn, gc);
    getContentPane().add(btn);
  }
}
