/**
 Classe: Arquivo
 Autor:  Ivan Mecenas
 Data:   15/11/2002
*/
import java.io.*;

public class Arquivo {

    // Atributos privados
    private Mensagem dispMsg;
    private int numRegs;
    private RandomAccessFile raf;
    private boolean arqExiste;

    // Construtor
    public Arquivo(Registro reg, String fileName, int qtdRegs) {
        dispMsg = new Mensagem();
        numRegs = qtdRegs;
        try {
            File arq = new File(fileName);
            arqExiste = arq.exists();
            raf = new RandomAccessFile(fileName, "rw");
            if (arqExiste == false) {
                raf.writeInt(0);
            }
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao abrir arquivo: " + ioe.toString());
        }
    }

    public void fecharArquivo() {
        try {
            raf.close();
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao fechar arquivo: " + ioe.toString());
        }
    }

    public void gravarRegistro(Registro reg) {
        int offset = reg.codigo;
        try {
            raf.seek(offset * reg.getTamRegistro());
            reg.setRegistro(raf);
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao gravar registro: " + ioe.toString());
        }
    }

    public void lerRegistro(Registro reg, int numReg) {
        int offset = numReg;
        try {
            raf.seek(offset * reg.getTamRegistro());
            reg.getRegistro(raf);
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao ler registro: " + ioe.toString());
        }
    }

    // Mtodos recuperadores
    public int getNumRegistros() {
        return numRegs;
    }

    public boolean getExisteArquivo() {
        return arqExiste;
    }

    public RandomAccessFile getRaf() {
        return raf;
    }
}
