/**
Classe: BufferUm
Autor:  Ivan Mecenas
Data:   26/09/2004
*/
import java.io.*;
import java.nio.*;
import java.nio.channels.*;

public class BufferUm {

  public static void main(String[] args) {
    // Cria varivel para guardar posio
    int p;

    // Cria o buffer
    CharBuffer buffer = CharBuffer.allocate(12);

    // Nesse momento capacity = limit e position = 0 (zero)
    System.out.println("Valor de capacity: " + buffer.capacity());
    System.out.println("Valor de limit:    " + buffer.limit());
    System.out.println("Valor de position: " + buffer.position());

    // Escreve "Ivan" a partir da posio zero
    buffer.put("Ivan");

    // Imprime o novo valor de position
    System.out.println("Valor de 'position' aps escrever 'Ivan': " + buffer.position());

    // Guarda e imprime o valor de position
    p = buffer.position();
    System.out.println("Valor de 'position' guardado em p: " + p);

    // Escreve um caractere em branco
    buffer.put(" ");

    // Escreve "Mecenas" a partir do valor atual de position
    buffer.put("Mecenas");

    // Imprime o novo valor de position
    System.out.println("Valor de 'position' aps escrever 'Mecenas': " + buffer.position());

    // Escreve os caracteres da posio 0 at a posio p menos 1
    for (int i = 0; i <= p-1 ; i++) {
      System.out.print(buffer.get(i));
    }

    // Quebra linha
    System.out.println("");

    // Escreve todos os caracteres
    for (int i = 0; i <= buffer.capacity() - 1 ; i++) {
      System.out.print(buffer.get(i));
    }

    // Quebra linha
    System.out.println("");
  }
}
