/**
 Classe: JanProduto
 Autor:  Ivan Mecenas
 Data:   15/11/2002
*/
import java.io.*;

public class JanProduto extends javax.swing.JFrame {

    private Mensagem dispMsg;
    private Arquivo arqProd;
    private Registro regProd;

    public JanProduto() {
        initComponents();
        dispMsg = new Mensagem();
        regProd = new Registro(96, 40);
        arqProd = new Arquivo(regProd, "C:\\Livros\\Java3ed\\Exemplos\\db\\Produto.dat", 100);
        if (!arqProd.getExisteArquivo()) {
          criaRegistros(arqProd.getRaf(), arqProd, regProd);
        }
    }

    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        textCodigo = new javax.swing.JTextField();
        textDescricao = new javax.swing.JTextField();
        textPreco = new javax.swing.JTextField();
        textEstoque = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();

        getContentPane().setLayout(null);

        setTitle("Janela de Produtos");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jLabel1.setText("Cdigo");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(40, 50, 39, 16);

        jLabel2.setText("Descrio");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(40, 80, 80, 16);

        jLabel3.setText("Preo");
        getContentPane().add(jLabel3);
        jLabel3.setBounds(40, 110, 34, 16);

        jLabel4.setText("Estoque");
        getContentPane().add(jLabel4);
        jLabel4.setBounds(40, 140, 46, 16);

        textCodigo.setName("textCodigo");
        textCodigo.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                aoPerderFoco(evt);
            }
        });

        getContentPane().add(textCodigo);
        textCodigo.setBounds(110, 50, 80, 20);

        textDescricao.setName("textDescricao");
        getContentPane().add(textDescricao);
        textDescricao.setBounds(110, 80, 280, 20);

        textPreco.setName("textPreco");
        getContentPane().add(textPreco);
        textPreco.setBounds(110, 110, 80, 20);

        textEstoque.setName("textEstoque");
        getContentPane().add(textEstoque);
        textEstoque.setBounds(110, 140, 80, 20);

        jButton1.setText("Gravar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aoGravar(evt);
            }
        });

        getContentPane().add(jButton1);
        jButton1.setBounds(40, 210, 72, 26);

        jButton2.setText("Excluir");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aoExcluir(evt);
            }
        });

        getContentPane().add(jButton2);
        jButton2.setBounds(120, 210, 73, 26);

        jButton3.setText("Limpar");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aoLimpar(evt);
            }
        });

        getContentPane().add(jButton3);
        jButton3.setBounds(200, 210, 74, 26);

        jButton4.setText("<<");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aoRecuar(evt);
            }
        });

        getContentPane().add(jButton4);
        jButton4.setBounds(288, 210, 50, 26);

        jButton5.setText(">>");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aoAvancar(evt);
            }
        });

        getContentPane().add(jButton5);
        jButton5.setBounds(340, 210, 50, 26);

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(400, 300));
        setLocation((screenSize.width-400)/2,(screenSize.height-300)/2);
    }

    private void aoAvancar(java.awt.event.ActionEvent evt) {
        int regAtual;
        boolean fimArquivo = false;

        if (!textCodigo.getText().trim().equals("")) {
            regAtual = Integer.parseInt(textCodigo.getText());
            if (++regAtual > arqProd.getNumRegistros()) {
                regAtual = Integer.parseInt(textCodigo.getText());
                fimArquivo = true;
            }
            arqProd.lerRegistro(regProd, regAtual);
            if (!regProd.descricao.trim().equals("null")) {
                textCodigo.setText("" + regProd.codigo);
                textDescricao.setText(regProd.descricao);
                textPreco.setText("" + regProd.preco);
                textEstoque.setText("" + regProd.estoque);
                if (fimArquivo) {
                    dispMsg.displayMessage("Fim de arquivo");
                    return;
                }
            }
            else {
                textCodigo.setText("" + regAtual);
                textDescricao.setText("");
                textPreco.setText("");
                textEstoque.setText("");
                if (fimArquivo) {
                    dispMsg.displayMessage("Fim de arquivo");
                    return;
                }
                ++regAtual;
                aoAvancar(evt);
            }
        }
    }

    private void aoRecuar(java.awt.event.ActionEvent evt) {
        int regAtual;
        boolean fimArquivo = false;

        if (!textCodigo.getText().trim().equals("")) {
            regAtual = Integer.parseInt(textCodigo.getText());
            if (--regAtual <= 0) {
                regAtual = Integer.parseInt(textCodigo.getText());
                fimArquivo = true;
            }
            arqProd.lerRegistro(regProd, regAtual);
            if (!regProd.descricao.trim().equals("null")) {
                textCodigo.setText("" + regProd.codigo);
                textDescricao.setText(regProd.descricao);
                textPreco.setText("" + regProd.preco);
                textEstoque.setText("" + regProd.estoque);
                if (fimArquivo) {
                    dispMsg.displayMessage("Incio de arquivo");
                    return;
                }
            }
            else {
                textCodigo.setText("" + regAtual);
                textDescricao.setText("");
                textPreco.setText("");
                textEstoque.setText("");
                if (fimArquivo) {
                    dispMsg.displayMessage("Incio de arquivo");
                    return;
                }
                --regAtual;
                aoRecuar(evt);
            }
        }
    }

    private void aoLimpar(java.awt.event.ActionEvent evt) {
        limpaCampos();
    }

    private void aoExcluir(java.awt.event.ActionEvent evt) {
        if (!textCodigo.getText().trim().equals("")) {
            regProd.codigo = Integer.parseInt(textCodigo.getText());
            regProd.descricao = "null";
            regProd.preco = 0.0;
            regProd.estoque = 0;
            arqProd.gravarRegistro(regProd);
        }
    }

    private void aoGravar(java.awt.event.ActionEvent evt) {
        if (!textCodigo.getText().trim().equals("")) {
            regProd.codigo = Integer.parseInt(textCodigo.getText());
            regProd.descricao = textDescricao.getText();
            regProd.preco = Double.parseDouble(textPreco.getText());
            regProd.estoque = Integer.parseInt(textEstoque.getText());
            arqProd.gravarRegistro(regProd);
        }
    }

    private void aoPerderFoco(java.awt.event.FocusEvent evt) {
        int regAtual;
        if (textCodigo.getText().trim().equals("")) {
            textDescricao.setText("");
            textPreco.setText("");
            textEstoque.setText("");
        }
        else {
            regAtual = Integer.parseInt(textCodigo.getText());
            if (regAtual > 0 && regAtual <= arqProd.getNumRegistros()) {
                arqProd.lerRegistro(regProd, regAtual);
                if (regProd.descricao.trim().equals("null")) {
                    textDescricao.setText("");
                    textPreco.setText("");
                    textEstoque.setText("");
                }
                else {
                    textCodigo.setText("" + regProd.codigo);
                    textDescricao.setText(regProd.descricao);
                    textPreco.setText("" + regProd.preco);
                    textEstoque.setText("" + regProd.estoque);
                }
            }
        }
    }

    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }
    
    public static void main(String args[]) {
        new JanProduto().setVisible(true);
    }

    private void criaRegistros(RandomAccessFile raf, Arquivo arq, Registro reg) {
        for (int i = 1; i <= arq.getNumRegistros(); i++) {
            reg.codigo = i;
            reg.descricao = "null";
            reg.preco = 0.0;
            reg.estoque = 0;
            arqProd.gravarRegistro(reg);
        }

        try {
            raf.seek(0);
            raf.writeInt(arq.getNumRegistros() * reg.getTamRegistro());
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao gravar registro: " + ioe.toString());
        }
    }

    private void limpaCampos() {
        textCodigo.setText("");
        textDescricao.setText("");
        textPreco.setText("");
        textEstoque.setText("");
        textCodigo.requestFocus();
    }

    private javax.swing.JLabel jLabel4;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton jButton1;
    private javax.swing.JTextField textEstoque;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton5;
    private javax.swing.JTextField textDescricao;
    private javax.swing.JButton jButton4;
    private javax.swing.JTextField textPreco;
    private javax.swing.JTextField textCodigo;
}