/**
 Classe: LerArquivoTextoDois
 Autor:  Ivan Mecenas
 Data:   18/11/2002
*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.URL;

public class LerArquivoTextoDois extends JFrame {
  private JTextArea jta;

  public LerArquivoTextoDois() {
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });

    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setSize(screenSize.width, screenSize.height-20);

    Container c = getContentPane();
    jta = new JTextArea("", 0, 0);
    c.add(new JScrollPane(jta));
    setVisible(true);
  }

  public static void main(String[] args) {
    LerArquivoTextoDois arqTxt = new LerArquivoTextoDois();
    File fileName;
    JFileChooser jfc = new JFileChooser();
    jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
    int result = jfc.showOpenDialog(arqTxt);

    if (result == JFileChooser.CANCEL_OPTION) return;
    fileName = jfc.getSelectedFile();

    if (fileName == null || fileName.getName().equals("")) {
    }
    else {
      try {
        arqTxt.leArquivoTexto(fileName.getName());
      }
      catch (IOException ioe) {
        JOptionPane.showMessageDialog(
          null,
          "Erro na leitura do arquivo",
          "Mensagem",
          JOptionPane.PLAIN_MESSAGE
          );
      }
    }
  }

  private void leArquivoTexto(String nomArq) throws IOException {
    URL url = getClass().getResource(nomArq);
    InputStreamReader isr = new InputStreamReader(url.openStream());
    BufferedReader br = new BufferedReader(isr);
    String lin = "";

    while ((lin = br.readLine()) != null) {
      jta.append(lin  + "\n");
    }

    br.close();
  }
}
