/**
 Classe: Registro
 Autor: Ivan Mecenas
 Data:  15/11/2002
*/
import java.io.*;

public class Registro {

    // Atributos privados
    private Mensagem dispMsg;
    private int tamRegistro;
    private int tamDescricao;

    // Atributos pblicos
    public int codigo;
    public String descricao;
    public double preco;
    public int estoque;

    // Construtor
    public Registro(int tamRegistro, int tamDescricao) {
        // Inicia atributos privados
        this.dispMsg = new Mensagem();
        this.tamRegistro = tamRegistro;
        this.tamDescricao = tamDescricao;

        // Inicia atributos pblicos
        this.codigo = 0;
        this.descricao = "null";
        this.preco = 0.0;
        this.estoque = 0;
    }

    // Mtodos para recuperar dados
    public void getRegistro(RandomAccessFile raf) {
        codigo = getInteger(raf);
        descricao = getString(raf, tamDescricao);
        preco = getDouble(raf);
        estoque = getInteger(raf);
    }

    private int getInteger(RandomAccessFile raf) {
        try {
            return raf.readInt();
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro na leitura do dado: " + ioe.toString());
            return 0;
        }
    }

    private String getString(RandomAccessFile raf, int tam) {
        char[] strRet = new char[tam];
        try {
            for(int i = 0; i < tam; i++)
            strRet[i] = raf.readChar();
            return new String(strRet).trim();
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro na leitura do dado: " + ioe.toString());
            return "";
        }
    }

    private double getDouble(RandomAccessFile raf) {
        try {
            return raf.readDouble();
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro na leitura do dado: " + ioe.toString());
            return 0.0;
        }
    }

    // Mtodos para gravar dados
    public void setRegistro(RandomAccessFile raf) {
        setInteger(raf, codigo);
        setString(raf, descricao, tamDescricao);
        setDouble(raf, preco);
        setInteger(raf, estoque);
    }

    private void setInteger(RandomAccessFile raf, int valor) {
        try {
            raf.writeInt(valor);
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao gravar o dado: " + ioe.toString());
        }
    }

    private void setString(RandomAccessFile raf, String valor, int tamValor) {
        if (valor.length() < tamValor) {
            for(int i = valor.length(); i < tamValor; i++)
            valor += " ";
        }
        try {
            for(int i = 0; i < tamValor; i++)
            raf.writeChar(valor.charAt(i));
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao gravar o dado: " + ioe.toString());
        }
    }

    private void setDouble(RandomAccessFile raf, double valor) {
        try {
            raf.writeDouble(valor);
        } catch(IOException ioe) {
            dispMsg.displayMessage("Erro ao gravar o dado: " + ioe.toString());
        }
    }

    // Mtodos recuperadores
    public int getTamRegistro() {
        return tamRegistro;
    }
}
