/**
 * Classe: ConexaoAccess
 * Autor:  Ivan Mecenas
 * Data:   12/10/2002
*/
import java.sql.*;
import javax.swing.*;

public class ConexaoAccess {

    final private String DRV = "sun.jdbc.odbc.JdbcOdbcDriver";
    private String url = "jdbc:odbc:Northwind";
    private String userName = "";
    private String password = "";
    private Connection conn;
    private Statement st;

    public ConexaoAccess(String url, String userName, String password) {
        this.url = url;
        this.userName = userName;
        this.password = password;
    }

    public boolean conecta() {
        boolean result = true;
        try {
            Class.forName(DRV);
            conn = DriverManager.getConnection(url, userName, password);
        }
        catch(java.lang.ClassNotFoundException erroClass) {
            mensagemErro(erroClass.getMessage());
            result = false;
        }
        catch(SQLException erroSQL) {
            mensagemErro(erroSQL.getMessage());
            result = false;
        }
        return result;
    }

    public void desconecta() {
        boolean result = true;
        try {
            conn.close();
        }
        catch(SQLException erroSQL) {
            mensagemErro(erroSQL.getMessage());
            result = false;
        }
    }

    public int regCount(String qry) {
        int result = 0;
        try {
            st = conn.createStatement();
            ResultSet rs = st.executeQuery(qry);
            rs.next();
            result = rs.getInt(1);
            st.close();
        }
        catch(SQLException sqlex) {
            mensagemErro(sqlex.getMessage());
        }
        return result;
    }

    public int exeQuery(String qry) {
        int result = 0;
        try {
            st = conn.createStatement();
            result = st.executeUpdate(qry);
            st.close();
        }
        catch(SQLException sqlex) {
            mensagemErro(sqlex.getMessage());
        }
        return result;
    }

    public String getColumn(String qry) {
        String result = "";
        try {
            st = conn.createStatement();
            ResultSet rs = st.executeQuery(qry);
            rs.next();
            result = rs.getString(1);
            st.close();
        }
        catch(SQLException sqlex) {
            mensagemErro(sqlex.getMessage());
        }
        return result;
    }

    public void getColumn(String qry, String[] reg) {
        try {
            Statement st = conn.createStatement();
            ResultSet rs = st.executeQuery(qry);
            rs.next();
            for (int i = 1; i <= reg.length; i++)
            reg[i-1] = rs.getString(i);
            st.close();
        }
        catch(SQLException sqlex) {
            mensagemErro(sqlex.getMessage());
        }
    }

    public void getColumn(String qry, String[][] reg, int lin) {
        try {
            System.out.println(qry);
            st = conn.createStatement();
            ResultSet rs = st.executeQuery(qry);
            for (int i = 1; i <= lin; i++) {
                if (rs.next())
                for (int n = 1; n <= reg[n].length; n++ )
                reg[i-1][n-1] = rs.getString(n);
            }
            st.close();
        }
        catch(SQLException sqlex) {
            mensagemErro(sqlex.getMessage());
        }
    }

    private void mensagemErro(String msg) {
        JOptionPane.showMessageDialog(
            null,
            msg,
            "Erro",
            JOptionPane.ERROR_MESSAGE);
    }
}
