/**
 Classe: MostraTabela
 Autor:  Ivan Mecenas
 Data:   24/09/2004
*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.sql.*;

public class MostraTabela extends JFrame {
    private JTable tabela;
    private Connection conn;

    public MostraTabela() {
        String DRV = "org.firebirdsql.jdbc.FBDriver";
        String url = "jdbc:firebirdsql:localhost/3050:" +
            "C:\\Livros\\Java3ed\\Exemplos\\db\\Employee.fdb";
        String userName = "SYSDBA";
        String password = "masterkey";
 
        // Carrega o driver Firebird
        try {
            Class.forName(DRV);
            conn = DriverManager.getConnection(url, userName, password);
        }
        catch (ClassNotFoundException cnfex) {
            System.err.println("No foi possvel carregar o driver." );
            cnfex.printStackTrace();
            System.exit(1); // Encerra o programa
        }
        catch (SQLException sqlex) {
            System.err.println("No foi possvel estabelecer conexo." );
            sqlex.printStackTrace();
        }

        pesquisaTabela();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new Dimension(450, 450));
        setLocation((screenSize.width-450)/2, (screenSize.height-450)/2);
        setVisible(true);
    }

    private void pesquisaTabela() {
        Statement comm;
        ResultSet resultSet;

        try {
            String query = "select * from Country";
            comm = conn.createStatement();
            resultSet = comm.executeQuery(query);
            exibeDados(resultSet);
            comm.close();
        }
        catch (SQLException sqlex) {
            sqlex.printStackTrace();
        }
    }

    private void exibeDados(ResultSet rs) throws SQLException {
        // Posiciona para o primeiro registro
        boolean registros = rs.next();

        // Verifica se a tabela contm registros
        if (!registros) {
            JOptionPane.showMessageDialog(this, "Tabela vazia!" );
            setTitle("Sem registros para exibir" );
            return;
        }

        setTitle("Pases");
        Vector colunas = new Vector();
        Vector linhas = new Vector();

        try {
            // Monta cabealhos das colunas
            ResultSetMetaData rsmd = rs.getMetaData();

            for (int i = 1; i <= rsmd.getColumnCount(); ++i)
            colunas.addElement(rsmd.getColumnName(i));

            do {
                linhas.addElement(proximoRegistro(rs, rsmd));
            } while (rs.next());

            // Exibe os dados
            tabela = new JTable(linhas, colunas);
            JScrollPane scroller = new JScrollPane(tabela);
            getContentPane().add(scroller, BorderLayout.CENTER);
            validate();
        }
        catch (SQLException sqlex) {
            sqlex.printStackTrace();
        }
    }

    private Vector proximoRegistro(ResultSet rs, ResultSetMetaData rsmd) throws SQLException {
        Vector linhaCorrente = new Vector();

        for (int i = 1; i <= rsmd.getColumnCount(); ++i)
        switch(rsmd.getColumnType(i)) {
        case Types.VARCHAR:
            linhaCorrente.addElement(rs.getString(i));
            break;
        case Types.INTEGER:
            linhaCorrente.addElement(new Long(rs.getLong(i)));
            break;
        default:
            System.out.println("Tipo: " + rsmd.getColumnTypeName(i));
        }

        return linhaCorrente;
    }

    public void fechaConexao() {
        try {
            conn.close();
        }
        catch (SQLException sqlex) {
            System.err.println( "No foi possvel encerrar a conexo." );
            sqlex.printStackTrace();
        }
    }

    public static void main(String args[]) {
        final MostraTabela app = new MostraTabela();
        app.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                app.fechaConexao();
                System.exit( 0 );
            }
        });
    }
}
